#include <stdio.h>
#include <cairo/cairo.h>
#include <math.h>


#include "lcd-display.h"

static lcdInfo_t *lcd;

int main(void) {
         
   cairo_t *cr;
   cairo_surface_t *sfc;
   
   if ((lcd = openDisplay()) == NULL) {
        fprintf(stderr, "ERROR: Can't open display\n");
        return 1;
   }

   sfc = cairo_image_surface_create_for_data((unsigned char *)lcd->frameBuffer, 
      CAIRO_FORMAT_A1, lcd->displayWidth, lcd->displayHeight, lcd->stride);
        
   if (sfc) {                        
      if ((cr = cairo_create(sfc))) {
         char buf[16];
         cairo_set_antialias(cr, CAIRO_ANTIALIAS_NONE);
         cairo_set_line_width(cr, 1.0);
         cairo_rectangle(cr, 2, 2, lcd->displayWidth-3, lcd->displayHeight-3); // a box                
         
         cairo_stroke(cr);      
         cairo_select_font_face(cr, "Sans", CAIRO_FONT_SLANT_NORMAL,
                               CAIRO_FONT_WEIGHT_BOLD);

         cairo_set_font_size(cr, 12.0);
         cairo_move_to(cr, 14, 17);

         cairo_show_text(cr, "Hello, World!");     // some text
         
         cairo_move_to(cr, 80, 50);
         cairo_line_to(cr, 100, 36);               // a line
         cairo_stroke(cr);
         
         cairo_arc(cr, 100, 36, 15, 0, 2 * M_PI);  // a circle         
         cairo_stroke(cr);
                  
         cairo_move_to(cr, 14, 36);

         snprintf(buf, sizeof(buf), "%d x %d", lcd->displayWidth, lcd->displayHeight);
         cairo_show_text(cr, buf);     // some more text

         cairo_move_to(cr, 20, 50);
         cairo_show_text(cr, "OLED");     // some more text
         
         cairo_surface_flush(sfc);
                     
         cairo_destroy(cr);                   
      }
   }

   closeDisplay();
   
   return 0;
}


